*** Settings ***
Library      String   
Library    Collections
Resource     ../Resources/Common.robot
Resource     ../Resources/Page Object/PageAccueil.resource
Resource     ../Resources/Page Object/PageCreateAccount.resource
Resource     ../Resources/Page Object/PageLogin.resource

Test Setup       Common.Démarrer Test            
Test Teardown    Common.Terminer Test
Documentation    Ex3:Lors de l'authentification via email, le champ mot de passe doit avoir une longueur comprise entre 6 et 30 caractères. Si non, un message d'erreur est affiché 

*** Variables ***
@{VALEURS_FORMULAIRES_EX03_CT02}=    ""    123456    jean hartin     123456
&{test_values_for_mdp_lenght_ok} =   "6_car"=654322    "7_car"=7654321    "29_car"=12345678911234567892123456789    "30_car"=123456789112345678921234567893    # 6    7    29    30
&{test_values_for_mdp_lenght_ko} =   "0_car"=${EMPTY}    "1_car"=1    "5_car"=12345    "31_car"=1234567891123456789212345678931    # 0    1    5    31

*** Test Cases ***
EX03-CT01
    # CT01 : "Affichage erreur avec email existant et:
    #   - longueur mdp = 0
    #   - longueur mdp = 1
    #   - longueur mdp = 5
    #   - longueur mdp = 31"
    PageAccueil.Valider l'affichage de la page "Accueil" - non connecté
    ${RANDOM_EMAIL}=    Common.Create Random Email
    ${VALEURS_FORMULAIRES_EX03_CT02}[0]=  Set Variable     ${RANDOM_EMAIL}
    PageCreateAccount.Créer un compte utilisateur avec email    @{VALEURS_FORMULAIRES_EX03_CT02}
    # Vérifier qu'on a bien créer un compte (Fait dans le "créer un compte utilisateur avec email")
    # Cliquer sur Se loger directement avec le lien sur la page de validation
    FOR    ${key}    IN      @{test_values_for_mdp_lenght_ko.keys()}
        IF    ${key} == "0_car"
            PageCreateAccount.Acceder a la page loggin - compte créé
            PageLogin.Vérifier l'affichage de la page "Login"
        END
        # Login avec champ password avec des longeurs OK    
        PageLogin.Remplir le formulaire de login    ${VALEURS_FORMULAIRES_EX03_CT02}[0]    ${test_values_for_mdp_lenght_ko}[${key}]
        # Vérifier que le formulaire est envoyé avec msg d'erreur sur le mot de passe
        Log To Console    Test longeur mot de passe KO avec ${key} : ${test_values_for_mdp_lenght_ko}[${key}]
        IF    ${key} == "0_car"
            PageLogin.Soumettre le formulaire de Login
            PageLogin.Vérifier Login KO - champ pwd vide
        ELSE
            PageLogin.Vérifier Login KO - pwd lenght KO
        END
    END

EX03-CT02
    # "Pas d'erreur affichée avec email existant et:
    #     - longueur mdp = 6
    #     - longueur mdp = 7
    #     - longueur mdp = 29
    #     - longueur mdp = 30"
    # Créer un compte email et se loger avec un mdp à tester
    PageAccueil.Valider l'affichage de la page "Accueil" - non connecté
    ${RANDOM_EMAIL}=    Common.Create Random Email
    ${VALEURS_FORMULAIRES_EX03_CT02}[0]=  Set Variable     ${RANDOM_EMAIL}
    PageCreateAccount.Créer un compte utilisateur avec email    @{VALEURS_FORMULAIRES_EX03_CT02}
    # Vérifier qu'on a bien créer un compte (Fait dans le "créer un compte utilisateur avec email")
    # Cliquer sur Se loger directement avec le lien sur la page de validation
    FOR    ${key}    IN      @{test_values_for_mdp_lenght_ok.keys()}
        IF    ${key} == "6_car"
            PageCreateAccount.Acceder a la page loggin - compte créé
            PageLogin.Vérifier l'affichage de la page "Login"
        END
        # Login avec champ password avec des longeurs OK    
        PageLogin.Remplir le formulaire de login    ${VALEURS_FORMULAIRES_EX03_CT02}[0]    ${test_values_for_mdp_lenght_ok}[${key}]
        PageLogin.Soumettre le formulaire de Login
        # Vérifier que le formulaire est envoyé avec msg d'erreur sur le mot de passe
        Log To Console    Test longeur mot de passe OK avec ${key} : ${test_values_for_mdp_lenght_ok}[${key}]
        PageLogin.Vérifier Login KO - email ou pwd incorrect    
    END

*** Keywords ***
